(function() {

    "use strict";

    var eventName = [
        "app.record.create.change.郵便番号",
        "app.record.edit.change.郵便番号"
    ];

    // 編集画面
    kintone.events.on(eventName, function(event) {
        // ハイフン有無に対応
        var postcode = event.record['郵便番号']['value'];
        // 前半３桁
        var post3 = '';
        // 後半４桁
        var post4 = '';
        if (postcode.length === 7) {
            post3 = postcode.slice(0, 3);
            post4 = postcode.slice(3, 7);
        } else if (postcode.length === 8) {
            post3 = postcode.slice(0, 3);
            post4 = postcode.slice(4, 8);
        }
        var url = 'https://madefor.github.io/postal-code-api/api/v1/'
        + post3 + '/' + post4 + '.json';

        // 外部API呼出
        kintone.proxy(url, 'GET', {}, {}).then(function(resp) {
            // 成功時
            if (resp[1] === 200) {
                // ステータス正常時
                // JSON文字列をJSONオブジェクトに変換
                var obj = JSON.parse(resp[0]);
                // 現在開いてるレコードデータをJSON形式で取得
                var record = kintone.app.record.get();
                record['record']['都道府県']['value'] = obj['data'][0]['ja']['prefecture'];
                record['record']['市区町村']['value'] = obj['data'][0]['ja']['address1'];
                record['record']['町域名']['value'] = obj['data'][0]['ja']['address2'];
                // 現在開いてるレコードに値をセット
                kintone.app.record.set(record);
            } else {
                // ステータス異常時
                alert(resp[1] + ":住所が見つかりませんでした。");
            }
        }, function(resp) {
            // 失敗時
            alert("住所の検索に失敗しました。");
        });
    });

    // 一覧画面
    kintone.events.on("app.record.index.edit.change.郵便番号", function(event) {
        var record = event.record;
        // ハイフン有無に対応
        var postcode = event.record['郵便番号']['value'];
        // 前半３桁
        var post3 = '';
        // 後半４桁
        var post4 = '';
        if (postcode.length === 7) {
            post3 = postcode.slice(0, 3);
            post4 = postcode.slice(3, 7);
        } else if (postcode.length === 8) {
            post3 = postcode.slice(0, 3);
            post4 = postcode.slice(4, 8);
        }
        var url = 'https://madefor.github.io/postal-code-api/api/v1/'
        + post3 + '/' + post4 + '.json';

        // 外部API呼出(同期通信)
        $.ajax({
            "url": url,
            "dataType": 'json',
            "async": false,
            "success": function(resp, status, xhr) {
                if (xhr.status === 200) {
                    // ステータス正常時
                    record['都道府県']['value'] = resp['data'][0]['ja']['prefecture'];
                    record['市区町村']['value'] = resp['data'][0]['ja']['address1'];
                    record['町域名']['value'] = resp['data'][0]['ja']['address2'];
                } else {
                    // ステータス異常時
                    alert(xhr.status + ":住所が見つかりませんでした。");
                }
            },
            "error": function(XMLHttpRequest, textStatus, errorThrown) {
                // 失敗時
                alert("住所の検索に失敗しました。");
            }
        });
        return event;
    });
})();
