(function() {
    "use strict";
    //レコード一覧画面の表示時に確度/小計フィールドの値に応じて文字色/背景色を変更する
    kintone.events.on('app.record.index.show', function(event) {
        var elKakudo = kintone.app.getFieldElements('確度');
        var elShokei = kintone.app.getFieldElements('小計');

        // 一覧画面の行数回繰り返し
        for (var i = 0; i < elKakudo.length; i++) {
            var record = event.records[i];

            // 確度フィールド
            switch (record['確度']['value']) {
                case "A":
                    elKakudo[i].style.color = 'blue';
                    elKakudo[i].style.fontSize = 'x-large';
                    elKakudo[i].style.fontWeight = 'bold';
                    break;
                case "B":
                    elKakudo[i].style.color = 'green';
                    elKakudo[i].style.fontSize = 'large';
                    elKakudo[i].style.fontWeight = 'bold';
                    break;
                case "C":
                    elKakudo[i].style.color = 'orange';
                    elKakudo[i].style.fontWeight = 'bold';
                    break;
            }

            // 小計フィールド
            if (Number(record['小計']['value']) >= 100000) {
                elShokei[i].style.backgroundColor = 'yellow';
                elShokei[i].style.fontWeight = 'bold';
            }
        }
    });

    // レコード詳細画面の表示時に確度/小計フィールドの値に応じて文字色/背景色を変更する
    kintone.events.on('app.record.detail.show', function(event) {
        var elKakudo = kintone.app.record.getFieldElement('確度');
        var elShokei = kintone.app.record.getFieldElement('小計');

        var record = event.record;

        // 確度フィールド
        switch (record['確度']['value']) {
            case "A":
                elKakudo.style.color = 'blue';
                elKakudo.style.fontSize = 'x-large';
                elKakudo.style.fontWeight = 'bold';
                break;
            case "B":
                elKakudo.style.color = 'green';
                elKakudo.style.fontSize = 'large';
                elKakudo.style.fontWeight = 'bold';
                break;
            case "C":
                elKakudo.style.color = 'orange';
                elKakudo.style.fontWeight = 'bold';
                break;
        }

        // 小計フィールド
        if (Number(record['小計']['value']) >= 100000) {
            elShokei.style.backgroundColor = 'yellow';
            elShokei.style.fontWeight = 'bold';
        }
    });
})();
