(function() {
    'use strict';

    kintone.events.on('app.record.index.show', function(event) {
        if (event.viewName !== 'devフィールドリスト') {
            // 「devフィールドリスト」以外の一覧の時は何もしない
            return;
        }
        var tbody = document.getElementById('confirm-field-code');

        kintone.api(kintone.api.url('/k/v1/form', true),
            'GET',
            { app: kintone.app.getId() },
            function(resp) {
                console.log(resp);
                var fields = resp.properties;
                for (var i = 0; i < fields.length; i++) {
                    if (fields[i].type === 'LABEL') {
                        // ラベルフィールドは表示しない
                        continue;
                    }
                    var tr = document.createElement('tr');

                    // フィールド名
                    var tdName = document.createElement('td');
                    tr.appendChild(tdName);

                    var div1Name = document.createElement('div');
                    div1Name.className = "kintoneplugin-table-td-control";
                    tdName.appendChild(div1Name);

                    var div2Name = document.createElement('div');
                    div2Name.innerText = fields[i].label;
                    div2Name.style.fontSize = "14px";
                    div2Name.className = "kintoneplugin-table-td-control-value";
                    div1Name.appendChild(div2Name);

                    // フィールドコード
                    var tdCode = document.createElement('td');
                    tr.appendChild(tdCode);

                    var div1Code = document.createElement('div');
                    div1Code.className = "kintoneplugin-table-td-control";
                    tdCode.appendChild(div1Code);

                    var div2Code = document.createElement('div');
                    div2Code.innerText = fields[i].code;
                    div2Code.style.fontSize = "14px";
                    div2Code.className = "kintoneplugin-table-td-control-value";
                    div1Code.appendChild(div2Code);

                    // フィールドタイプ
                    var tdType = document.createElement('td');
                    tr.appendChild(tdType);

                    var div1Type = document.createElement('div');
                    div1Type.className = "kintoneplugin-table-td-control";
                    tdType.appendChild(div1Type);

                    var div2Type = document.createElement('div');
                    div2Type.innerText = fields[i].type;
                    div2Type.style.fontSize = "14px";
                    div2Type.className = "kintoneplugin-table-td-control-value";
                    div1Type.appendChild(div2Type);

                    tbody.appendChild(tr);
                }
            }
        );
    });
})();

